=== debian/changelog ===
ros-noetic-prbt-hardware-support (0.6.0-1focal) focal; urgency=high

  * Ports the driver to noetic. Includes moveing the trajectory planner to moveit
    * changes the references of the pilz_command_planner to the pilz_industrial_command_planner in moveit
    * fixes compatibility with ubuntu 20, noetic and colcon
    * changes CI to noetic and ubuntu 20
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 18 Apr 2021 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.21-1focal) focal; urgency=high

  * Move OperationMode msg and GetOperationMode srv to pilz_msgs
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 22 Nov 2020 23:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.20-1focal) focal; urgency=high

  * Fix catkin_lint errors (#459)
  * Update acceptancetest_stop1.md (#447)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 16 Nov 2020 23:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.19-1focal) focal; urgency=high

  * Enhance safety interface launchfiles
  * Use arguments of top-level launch file in modbus_client.launch
  * Remove unncessary launch arg
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 06 Sep 2020 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.18-1focal) focal; urgency=high

  * Make AsyncTest header-only
  * Move modbus connection checker function in separate file
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 01 Jul 2020 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.17-1focal) focal; urgency=high

  * Infinite modbus connection retries
  * Improved modbus error messages
  * New modbus api
  * Refactor components to use Cartesian speed monitor functionality in controller
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 21 Jun 2020 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.16-1focal) focal; urgency=high

  * Update and apply clang-format (#387)
  * Make test-subfolder-names consistent (#380)
  * Extend stop1 acceptance test (#378)
  * Fix namespace in launch-file (#383)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Thu, 14 May 2020 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.15-1focal) focal; urgency=high

  * Add support for starting the robot without modbus
  * sto for hw definition is now called safety_hw everywhere
  * Moved system_info_node to prbt_support
  * Adopted default configuration for launchfiles
  * Renaming of STO into RUN_PERMITTED
  * Enable starting ROS without modbus connection
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sat, 02 May 2020 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.14-1focal) focal; urgency=high

  * Trim firmware string.
  * Rename waitForTopic() -> waitForMessage()
  * Add Status Indicator that shows operation mode, speed override, HW status and ROS status
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 10 Mar 2020 23:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.13-1focal) focal; urgency=high

  * Use brake-test definitions from pilz_msgs
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 03 Dec 2019 23:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.12-1focal) focal; urgency=high

  * Remove srv definition for speed override (moved to the package pilz_msgs)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 27 Nov 2019 23:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.11-1focal) focal; urgency=high

  * Fix clang compiler errors (#283)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Thu, 21 Nov 2019 23:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.10-1focal) focal; urgency=high

  * Add missing dependency on tf2_geometry_msgs (#264 <https://github.com/PilzDE/pilz_robots/issues/264>)
  * Minor fixes
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 07 Oct 2019 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.9-1focal) focal; urgency=high

  * Add service for getting the global speed override
  * Add modbus register for enabling temporary movement
  * Add Frame speed monitoring
  * Test fixes and improvements
  * Contributors: Pilz GmbH and Co. KG
  * Add speed observing dependent on operation mode
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 06 Oct 2019 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.8-1focal) focal; urgency=high

  * add missing transition to RUN_PERMITTED state machine
  * revise RUN_PERMITTED specification
  * integrate clang-tidy via CMake flag
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 09 Sep 2019 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.7-1focal) focal; urgency=high

  * Add state machine for RUN_PERMITTED handling to allow skipping of hold/unhold if needed
  * add operation mode functionality
  * add write capability to PilzModbusReadClient, rename PilzModbusReadClient -> PilzModbusClient
  * enter hold mode at braketest execution
  * automatically determine range for reading modbus registers
  * only read modbus registers that are explicitly configured (not in a single block)
  * separate api definitions for read and write
  * brake test result can be sent to FS controller
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 28 Aug 2019 22:00:00 -0000

ros-noetic-prbt-hardware-support (0.5.6-1focal) focal; urgency=high

  * Essentially reverts wrong fix (depend on canopen_chain_node) from 0.5.5

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 11 Jun 2019 22:00:00 -0000


