=== debian/control ===
Source: ros-noetic-prbt-hardware-support
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), libmodbus-dev, ros-noetic-canopen-chain-node, ros-noetic-catkin, ros-noetic-cmake-modules, ros-noetic-code-coverage, ros-noetic-dynamic-reconfigure, ros-noetic-message-filters, ros-noetic-message-generation, ros-noetic-pilz-msgs, ros-noetic-pilz-testutils, ros-noetic-pilz-utils, ros-noetic-roscpp, ros-noetic-rostest, ros-noetic-rosunit, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-urdf
Homepage: https://wiki.ros.org/prbt_hardware_support
Standards-Version: 3.9.2

Package: ros-noetic-prbt-hardware-support
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-message-runtime, ros-noetic-pilz-msgs, ros-noetic-roscpp, ros-noetic-rosservice, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs
Description: Control hardware functions of the PRBT manipulator like RUN_PERMITTED for Stop1 functionality.
